CONST
  Max_X       = 640 - 1;
  Max_Y       = 350 - 1;

  Max_X_DIV_2 = Max_X DIV 2;
  Max_Y_DIV_2 = Max_Y DIV 2;

  NoFPoints   = 400;
  StarSpeed   = 1;

TYPE
  TPoint3D = RECORD
               X:Integer;
               Y:Integer;
               Z:Integer;
             END;

VAR
  Stars : ARRAY[1..NoFPoints] OF TPoint3D;


 PROCEDURE VideoMode(Mode:Word); ASSEMBLER;
 ASM
   MOV AX, Mode
   INT 10h
 END;

 PROCEDURE VRetrace; ASSEMBLER;
 ASM
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
 END;

 FUNCTION KeyPressed: Boolean; ASSEMBLER;
 ASM
   MOV AH,1
   INT 16H
   MOV AL, True
   JNZ @End
   MOV AL, False
 @End:
 END;

 PROCEDURE PutPixel(X,Y:Word; Color:Byte); ASSEMBLER;
 ASM
   MOV DX, $3CE
   XOR AL, AL
   MOV AH, Color
   AND AH, $0F
   OUT DX, AX
   MOV AX, $0F01
   OUT DX, AX
   MOV AL, $08
   OUT DX, AL

   MOV ES, SegA000
   MOV BX, X
   MOV CX, BX
   MOV AX, 80
   MUL Y;
   SHR BX, 1
   SHR BX, 1
   SHR BX, 1
   ADD BX, AX
   AND CL, $07
   MOV AL, $80
   SHR AL, CL
   MOV DX, $3CF
   OUT DX, AL
   MOV AH, $FF
   OR ES:[BX],AH
 END;


PROCEDURE InitStars;
VAR Index:Integer;
BEGIN
  Randomize;
  FOR Index := 1 TO NoFPoints DO
  BEGIN
    Stars[Index].X := (Random(2000)-1000);
    Stars[Index].Y := (Random(2000)-1000);
    Stars[Index].Z := (Random(400)+1);
  END;
END;


PROCEDURE MoveStars;
CONST
  ExpF = 35;

VAR
  TempX     : Integer;
  TempY     : Integer;

  StarsX    : Integer;
  StarsY    : Integer;
  StarsZ    : Integer;

  TempColor : Byte;
  Index     : Integer;
  DrawStar  : Boolean;


  PROCEDURE CalcTempXY; NEAR;
  BEGIN
    TempX := (StarsX * Expf) DIV StarsZ + Max_X_DIV_2;
    TempY := (StarsY * Expf) DIV StarsZ + Max_Y_DIV_2;
  END;


BEGIN
  REPEAT
    VRetrace;
    FOR Index := 1 TO NoFPoints DO
    BEGIN
      DrawStar := True;
      StarsX := Stars[Index].X;
      StarsY := Stars[Index].Y;
      StarsZ := Stars[Index].Z;
      CalcTempXY;
      PutPixel(TempX,TempY,0);

      StarsZ := StarsZ - StarSpeed;
      IF (StarsZ <= 0) THEN StarsZ := 400;
      Stars[Index].Z := StarsZ;

      IF StarsZ  < 300 THEN TempColor := $7;
      IF StarsZ  < 100 THEN TempColor := $F;
      IF StarsZ >= 200 THEN TempColor := $8;

      CalcTempXY;
      IF (TempX < 0) OR (TempX > Max_X) OR
         (TempY < 0) OR (TempY > Max_Y) THEN DrawStar := False;
      IF DrawStar THEN PutPixel(TempX,TempY,TempColor);
    END;
  UNTIL KeyPressed;
END;


BEGIN
  VideoMode($10);
  InitStars;
  MoveStars;
  VideoMode($3);
END.